    /*   
modified on Sep 27, 2020
Modified by MohammedDamirchi from https://github.com/mikalhart/TinyGPSPlus
Home 
I tried to add stuff from GPS_Ublox_Sware_Serial_V007, and it works.
(But I do not really understand why)
*/ 
#define Version "TinyGPSPlusLCD2"
#include <TinyGPS++.h>
#include <SoftwareSerial.h>
#include <LiquidCrystal_I2C.h>
/*
   This sample sketch demonstrates the normal use of a TinyGPS++ (TinyGPSPlus) object.
   It requires the use of SoftwareSerial, and assumes that you have a
   9600-baud serial GPS device hooked up on pins 4(rx) and 3(tx).
*/
static const int RXPin = 4, TXPin = 3;
static const uint32_t GPSBaud = 9600;

unsigned long  freq  ;
unsigned long  freq_h;
byte freq_block;     // hex bytes we write to GPS
byte freq_block2;    // hex bytes we write to GPS
byte freq_block3;    // hex bytes we write to GPS
byte phase_block;    // hex bytes we write to GPS
byte phase_block2;   // hex bytes we write to GPS
long phase;
long phase_h;


// The TinyGPS++ object
TinyGPSPlus gps;

// The serial connection to the GPS device
SoftwareSerial ss(RXPin, TXPin);
LiquidCrystal_I2C  lcd(0x27,20,4); 

void setup()
{
  Serial.begin(115200);
  lcd.init();                            // 16 char x 2 line LCD display
  lcd.backlight();
  lcd.print(Version);
  delay(1000);
  lcd.clear();
  
  ss.begin(GPSBaud);

  Serial.println(F("DeviceExample.ino"));
  Serial.println(F("A simple demonstration of TinyGPS++ with an attached GPS module"));
  Serial.print(F("Testing TinyGPS++ library v. ")); Serial.println(TinyGPSPlus::libraryVersion());
  Serial.println(F("by Mikal Hart"));
  Serial.println();

    freq = 1000000;
    write_freq();
    lcd.setCursor(0,1);
    lcd.print(freq);
    lcd.print("Hz out");

    
}

void loop()
{
  // This sketch displays information every time a new sentence is correctly encoded.
  while (ss.available() > 0)
    if (gps.encode(ss.read()))
      displayInfo();

  if (millis() > 5000 && gps.charsProcessed() < 10)
  {
    Serial.println(F("No GPS detected: check wiring."));
    while(true);
  }
}

void displayInfo()
{
  Serial.print(F("Location: ")); 
  if (gps.location.isValid())
  {
    Serial.print(gps.location.lat(), 6);
    Serial.print(F(","));
    Serial.print(gps.location.lng(), 6);
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.print(F("  Date/Time: "));
  if (gps.date.isValid())
  {
    Serial.print(gps.date.month());
    Serial.print(F("/"));
    Serial.print(gps.date.day());
    Serial.print(F("/"));
    Serial.print(gps.date.year());
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.print(F(" "));
  if (gps.time.isValid())
  {
    if (gps.time.hour() < 10) Serial.print(F("0"));
    Serial.print(gps.time.hour());
    Serial.print(F(":"));
    if (gps.time.minute() < 10) Serial.print(F("0"));
    Serial.print(gps.time.minute());
    Serial.print(F(":"));
    if (gps.time.second() < 10) Serial.print(F("0"));
    Serial.print(gps.time.second());
    Serial.print(F("."));
    if (gps.time.centisecond() < 10) Serial.print(F("0"));
    Serial.print(gps.time.centisecond());
    LCD_Time();
  }
  else
  {
    Serial.print(F("INVALID"));
  }

  Serial.println();  }


  void LCD_Time ()
    { lcd.setCursor(0,0);
    lcd.print("AEST ");
  if (gps.time.hour() < 10) lcd.print(F("0"));
    lcd.print(gps.time.hour());
    lcd.print(F(":"));
    if (gps.time.minute() < 10) lcd.print(F("0"));
    lcd.print(gps.time.minute());
    lcd.print(F(":"));
    if (gps.time.second() < 10) Serial.print(F("0"));
    lcd.print(gps.time.second());
    lcd.print(F("."));
    if (gps.time.centisecond() < 10) lcd.print(F("0"));
    lcd.print(gps.time.centisecond());
 }


void calcChecksum(byte *checksumPayload, byte payloadSize) {
  byte CK_A = 0, CK_B = 0;
  for (int i = 0; i < payloadSize ;i++) {
    CK_A = CK_A + *checksumPayload;
    CK_B = CK_B + CK_A;
    checksumPayload++;  }
  *checksumPayload = CK_A;
  checksumPayload++;
  *checksumPayload = CK_B;
}// end of void calcChecksum

void sendUBX(byte *UBXmsg, byte msgLength) {
  for(int i = 0; i < msgLength; i++) {
    ss.write(UBXmsg[i]);
    ss.flush();  }
    ss.println();
    ss.flush();
   } // end of void sendUBX



byte getUBX_ACK(byte *msgID) {
  byte CK_A = 0, CK_B = 0;
  byte incoming_char;
  boolean headerReceived = false;
  unsigned long ackWait = millis();
  byte ackPacket[10] = {0xB5, 0x62, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
  int i = 0;
 
  while (1) {
    if (ss.available()) {
      incoming_char = ss.read();
      if (incoming_char == ackPacket[i]) { i++; }
      else if (i > 2) {    ackPacket[i] = incoming_char;   i++;  }    }
  
     if (i > 9) break;
    if ((millis() - ackWait) > 1500) {
      lcd.setCursor(0,0);  lcd.print(" Update Failed  ");
//      Serial.println("ACK Timeout");
      return 5;   }
      
    if (i == 4 && ackPacket[3] == 0x00) { ss.println("NAK Received"); return 1; }
  }

  for (i = 2; i < 8 ;i++) {
  CK_A = CK_A + ackPacket[i];
  CK_B = CK_B + CK_A;
  }
  if (msgID[0] == ackPacket[6] && msgID[1] == ackPacket[7] && CK_A == ackPacket[8] && CK_B == ackPacket[9]) {
 //   Serial.println("Success!");
    lcd.setCursor(0,0);  lcd.print("   updated      ");
 //   Serial.print("ACK Received! ");
    return 10;  }
  else {
    Serial.print("ACK Checksum Failure: ");
    delay(1000);
    return 1;  }
}   // end of byte getUBX_ACK



  void write_freq( ) {

  freq_h=freq,HEX;                                                           // this bit makes the DEC frequency into HEX
  freq_block= (freq_h %0x100);                                               // this bit builds the HEX bytes in order
  ss.print("   Calculated Hex Freq Bytes "); ss.print(freq_block,HEX);    // this bit builds the HEX bytes in order
  freq_h = freq_h/0x100;                                                     // this bit builds the HEX bytes in order
  freq_block2= freq_h %0x100;                                                // this bit builds the HEX bytes in order
  ss.print("  ");  ss.print(freq_block2,HEX);                        // this bit builds the HEX bytes in order
  freq_h = freq_h/0x100;                                                     // this bit builds the HEX bytes in order
  freq_block3= freq_h %0x100;                                                // this bit builds the HEX bytes in order
  ss.print("  ");  ss.print(freq_block3,HEX);                        // this bit builds the HEX bytes in order
  ss.print("   "); ss.print(freq);ss.println(" Hz"); 
    
   phase_h= phase,HEX;                                                           // this bit makes the DEC phaseuency into HEX
   phase_block= (phase_h %0x100);                                                // this bit builds the HEX phase in order
  ss.print("   Calculated Hex phase Bytes "); ss.print(phase_block,HEX); // this bit builds the HEX phase in order
  phase_h = phase_h/0x100;                                                       // this bit builds the HEX phase in order
  phase_block2= phase_h %0x100;                                                  // this bit builds the HEX phase in order
  ss.print("  ");  ss.print(phase_block2,HEX);                           // this bit builds the HEX phase in order
  ss.print("       "); ss.print(phase);ss.println(" nSec");
  
    byte Hz []=   {0xB5, 0x62, 0x06, 0x31, 0x20, 0x00, 0x00, 0x07, 0x00, 0x20, 0x32, 0x00, 0x00, 0x00, 0x01,
                   0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00 ,0x00 ,0x00 ,0x80, 
                   0x00 ,0x00, 0x00, 0x00 ,0xEF ,0x00 ,0x00 ,0x00 ,0xA9 ,0x60   } ;          
       
 //   Hz [14]= freq_block;  Hz [15]= freq_block2;  Hz [16]= freq_block3;   // for unlocked freq generation
      Hz [18]= freq_block;  Hz [19]= freq_block2;  Hz [20]= freq_block3;   // for GPS locked freq generation
      
      Hz [10]= phase_block;  Hz [11]= phase_block2;
//    for ( int i = 0;  i < 43; i++) {Serial.print( Hz [i],HEX);Serial.print(" ");}Serial.println();
      
    ss.print("Write freq & phase   ");
    calcChecksum(&Hz[2], sizeof(Hz) - 4);                   // makes the checksum
    sendUBX(Hz, sizeof(Hz));                                // Send the HEX
    byte gpsSetSuccess = 0;
    gpsSetSuccess += getUBX_ACK(&Hz[2]) ;
    ss.println(); } // end of void write_freq
